package com.github.wakfudecrypt.types.data

import com.github.wakfudecrypt._

@BinaryDecoder
case class StaticEffect(
  effectId: Int,
  actionId: Int,
  parentId: Int,
  areaOrderingMethod: Short,
  areaSize: Array[Int],
  areaShape: Short,
  emptyCellsAreaOrderingMethod: Short,
  emptyCellsAreaSize: Array[Int],
  emptyCellsAreaShape: Short,
  triggersBeforeComputation: Array[Int],
  triggersBeforeExecution: Array[Int],
  triggersForUnapplication: Array[Int],
  triggersAfterExecution: Array[Int],
  triggersAfterAllExecutions: Array[Int],
  triggersNotRelatedToExecutions: Array[Int],
  triggersAdditionnal: Array[Int],
  criticalState: String,
  targetValidator: Array[Long],
  affectedByLocalisation: Boolean,
  durationBase: Int,
  durationInc: Float,
  endsAtEndOfTurn: Boolean,
  isDurationInFullTurns: Boolean,
  applyDelayBase: Short,
  applyDelayIncrement: Float,
  params: Array[Float],
  probabilityBase: Float,
  probabilityInc: Float,
  triggerListenerType: Byte,
  triggerTargetType: Byte,
  triggerCasterType: Byte,
  _31: Int,
  storeOnSelf: Boolean,
  maxExecution: Short,
  maxExecutionIncr: Float,
  maxTargetCount: Byte,
  isFightEffect: Boolean,
  hmiAction: String,
  containerMinLevel: Short,
  containerMaxLevel: Short,
  effectCriterion: String,
  effectParentType: String,
  effectContainerType: String,
  dontTriggerAnything: Boolean,
  isPersonal: Boolean,
  isDecursable: Boolean,
  notifyInChatForCaster: Boolean,
  notifyInChatForTarget: Boolean,
  notifyInChatWithCasterName: Boolean,
  scriptFileId: Int,
  durationInCasterTurn: Boolean,
  effectProperties: Array[Int],
  displayInSpellDescription: Boolean,
  displayInStateBar: Boolean,
  recomputeAreaOfEffectDisplay: Boolean,
  isInTurnInFight: Boolean,
  notifyInChat: Boolean
)

object StaticEffect extends BinaryDataCompanion[StaticEffect] {
  override val dataId = 68
}
